Package: ShinyWizard
Title: An Interactive Wizard to Design, Build, and Deploy R Packages
        Demo Presentation
Version: 1.1.3.11
Authors@R: 
    person("Rafal", "Urniaz", , "rafal.urniaz@cantab.net", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0003-0192-2165"))
Description: Design, build, and deploy R packages demo presentations by an interactive wizard. Set up unique title, logo and themes. Add personalized tabs exposing applicability. And deploy as a part of a package or an independent app. 
License: GPL (>= 3)
Encoding: UTF-8
Imports: base, rstudioapi
RoxygenNote: 7.3.2
Suggests: testthat (>= 3.0.0), devtools, shinythemes, shinydashboard,
        shinyWidgets, shinyjs, yaml, readr, stringr, bslib, reshape2,
        shinytest2
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2024-10-26 00:12:40 UTC; urniaz
Author: Rafal Urniaz [aut, cre] (<https://orcid.org/0000-0003-0192-2165>)
Maintainer: Rafal Urniaz <rafal.urniaz@cantab.net>
Repository: CRAN
Date/Publication: 2024-10-28 13:00:02 UTC
Built: R 4.6.0; ; 2026-04-25 12:47:48 UTC; unix

Package: ShinyWizard
Title: An Interactive Wizard to Design, Build, and Deploy R Packages
        Demo Presentation
Version: 1.1.3.11
Authors@R: 
    person("Rafal", "Urniaz", , "rafal.urniaz@cantab.net", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0003-0192-2165"))
Description: Design, build, and deploy R packages demo presentations by an interactive wizard. Set up unique title, logo and themes. Add personalized tabs exposing applicability. And deploy as a part of a package or an independent app. 
License: GPL (>= 3)
Encoding: UTF-8
Imports: base, rstudioapi
RoxygenNote: 7.3.2
Suggests: testthat (>= 3.0.0), devtools, shinythemes, shinydashboard,
        shinyWidgets, shinyjs, yaml, readr, stringr, bslib, reshape2,
        shinytest2
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2024-10-26 00:12:40 UTC; urniaz
Author: Rafal Urniaz [aut, cre] (<https://orcid.org/0000-0003-0192-2165>)
Maintainer: Rafal Urniaz <rafal.urniaz@cantab.net>
Repository: CRAN
Date/Publication: 2024-10-28 13:00:02 UTC
Built: R 4.6.0; ; 2026-04-27 03:15:43 UTC; unix

#' Save config.yaml

load_config.yaml <- function(input, output, session){
  
  # Save config
  #  - Load configuration file from Temp Proj Dir
  temp_config <- yaml::yaml.load_file(paste0(config$TempProjPath,'config.yaml'))
  
  #  - Update original variables
 
  # Assign values to input
  shinyjs::runjs(paste0("document.getElementById('tab2-AppTitleInput').value = '",temp_config$AppTitle,"'"))
  shinyjs::runjs(paste0("document.getElementById('tab2-AppSubTitleInput').value = '",temp_config$AppSubTitle,"'"))
  shinyjs::runjs(paste0("document.getElementById('tab2-LogoFilePathInput').value = '",temp_config$LogoFilePath,"'"))
  shinyjs::runjs(paste0("document.getElementById('tab2-FooterTextInput').value = '",temp_config$FooterText,"'"))
  shinyjs::runjs(paste0("document.getElementById('tab2-shinytheme-selector').value = '",temp_config$ShinyWizzardTheme,"'"))
  
  # Assign values to text
  shinyjs::runjs(paste0("document.getElementById('AppTitle').textContent = '",temp_config$AppTitle,"'"))
  shinyjs::runjs(paste0("document.getElementById('AppSubTitle').textContent = '",temp_config$AppSubTitle,"'"))
  shinyjs::runjs(paste0("document.getElementById('LogoFilePath').textContent = '",temp_config$LogoFilePath,"'"))
  shinyjs::runjs(paste0("document.getElementById('FooterText').textContent = '",temp_config$FooterText,"'"))
  shinyjs::runjs(paste0("document.getElementById('FooterText').textContent = '",temp_config$FooterText,"'"))
  
  # Assign Theme
  shinyjs::runjs(paste0("document.getElementById('tab2-shinytheme-selector').dispatchEvent(new Event('change'));"))
  
}

#' Generate html footer on the bottom of the page

GenInfoIcon <- function(id, InfoTitle, InfoMessage){
  fluidRow(
  actionButton(inputId = id, #<--- remember to ns() all IDs, the IDs corresponds to output in server file 
               label = HTML("<i class='fas fa-info-circle'></i>"),
               style='position: fixed; bottom: 0; right: 0; margin-bottom: 60px; height: 80px;' ),
  
  tags$script(paste0("/*jslint browser:true*/
               document.getElementById('",id,"').addEventListener('click', function() {swal('",InfoTitle,"', '",InfoMessage,"', 'info');});"))
  
  )
}

# -- Download --- >

output$DownloadShinyWizardZIP <- downloadHandler(
  filename = function() {
    paste("ShinyWizard-", format(Sys.time(), "%d-%m-%y-%X"), ".zip", sep="")
  },
  content = function(file) {
    # change wd
    temp <- getwd()
    setwd(config$TempProjPath)
    # save all files  
    utils::zip(file, c('config.yaml', 'tabs'))
    setwd(temp)
  }
)


output$result <- renderText({(paste(config$TempProjPathTabs, "/ + /", getwd()))})

#' Generate html footer on the bottom of the page

GenFooter <- function(){
  
  # Changing this part without written permission is a violation of the license.
  HTML(paste0("<div style='position: fixed; padding: 10px 30px 10px 10px; bottom: 0; height: 30; width: 100%; background: inherited; text-align: right'>Created with <a href='https://github.com/urniaz/ShinyWizard' target='_blank'>ShinyWizard</a> © ver.",packageVersion('ShinyWizard'),"<div id ='FooterText'>", config$FooterText, "</div></div>"))

}

#' Generate Tabs UI 

GenNavTabsUI <- function(){
  
  # List tabs
  TabsFiles <- list.files("tabs/")
  tabs <- NULL
  
  for (i in seq_along(TabsFiles)){
    
    FilePath <- paste0("tabs/",TabsFiles[i],"/ui.R")
    
    # Extract values from comments 
    FileContent <-readr::read_file(file = FilePath)
      # --- Navigation ---
      TabName <- str_match(FileContent, "# TabName:\\s*(.*?)\\s*\n")[1,2]
      TabIcon <- str_match(FileContent, "# TabIcon:\\s*(.*?)\\s*\n")[1,2]
      # --- Next/Prev buttons
      ShowButtons <- str_match(FileContent, "# ShowButtons:\\s*(.*?)\\s*\n")[1,2]
          if (is.na(ShowButtons)){ ShowButtons <- TRUE}
      ButtonsAlignment <- str_match(FileContent, "# ButtonsAlignment:\\s*(.*?)\\s*\n")[1,2]
          if (is.na(ButtonsAlignment)){ ButtonsAlignment <- "center" }
      # --- Info ---
      InfoTitle <- str_match(FileContent, "# InfoTitle:\\s*(.*?)\\s*\n")[1,2]
      InfoMessage <- str_match(FileContent, "# InfoMessage:\\s*(.*?)\\s*\n")[1,2]
      
    if ((file.info(FilePath)$size != 0) && (trimws(na.omit(FileContent )) != "")){
      
      # Rebuild file
      pre <- paste0("ns <- NS('tab",i,"')")
      temp <- tempfile()
      write_file(pre,temp)
      write('# add new line after',temp, append = TRUE, sep = "\n")
      write_file(FileContent,temp, append = TRUE)
      
      # Generate tabs
      tabs[[i]] <-  tabPanel(if(is.na(TabName)){paste0("Tab",i)}else{TabName},
                             # Icon
                             icon = if(is.na(TabIcon)){NULL}else{icon(TabIcon, verify_fa = FALSE)},
                             # Value
                             value = paste0("tab", i),
                             # Load code
                             try(source(temp, local = TRUE)$value), # $value to not show TRUE text in console
                             # Generate buttons
                             div(style = "position: fixed; padding: 10px 30px 50px 10px; bottom: 0; width: 100%; background: inherited;", if (ShowButtons){ next_prev_button(i, length(TabsFiles), ButtonsAlignment)} ),
                             # Generate info button
                             if (is.na(InfoMessage) == FALSE){ GenInfoIcon(id = NS(paste0("tab", i),"info"), InfoTitle, InfoMessage) }
      )
    }
 }

  # Navigation Bar
  tabs$id <- NS("NavBar", "tabs") # NavBar id = NavBar-tabs
  tabs$theme <-  shinytheme(config$ShinyWizzardTheme) 
  tabs$title <- config$NavTabName
  tabs <- do.call("navbarPage", tabs)
  tabs
  
}

#' Generate next prev buttons 
next_prev_button <- function(i, len, ButtonsAlignment = "none", PrevName = "Prev", NextName = "Next"){
  
  PrevButton <- NULL
  PrevButton <- if (i > 1) actionButton(NS("NavBar", paste0("go_", i, "_", i-1)), PrevName)
  
  NextButton <- NULL
  NextButton <- if (i < len) actionButton(NS("NavBar", paste0("go_", i, "_", i+1)), NextName)
  
  switch(ButtonsAlignment,
         "center" = {
           fluidRow(
             column(5,""),
             column(1, PrevButton),
             column(1, NextButton),
             column(5,""))
         },
         "right"   = {
           fluidRow(
             column(10,""),
             column(1, PrevButton),
             column(1, NextButton))
         },
         "left"  = {
           fluidRow(
             column(1, PrevButton),
             column(1, NextButton),
             column(10,""))
         },
         "none"  = {
           PrevButton
           NextButton
         }
         )
}

# -- Current tab index --- >
tabIndex <- reactiveVal(0)
currentTabIndexes <- reactiveVal()


# -- Add Tab --- >

observeEvent(input$newTab, {
  
  uiContent <-  paste("# --- Navigation ---",
        paste0("# TabName: Tab", tabIndex()),
        "# TabIcon: file",
        "# --- Next/Prev buttons",
        "# ShowButtons: TRUE",
        "# ButtonsAlignment: center",
        "# --- Info ---",
        paste0("# InfoTitle: Tab", tabIndex()),
        "# InfoMessage: Info about tab",
        'fluidPage(
selectInput(ns("dataset"), label = "Dataset", choices = ls("package:datasets")),
                                                          verbatimTextOutput(ns("summary")),
                                                          tableOutput(ns("table"))
                                                          )',
        sep="\n")
  
  serverContent <- '  output$summary <- renderPrint({
                                                          dataset <- get(input$dataset, "package:datasets")
                                                          summary(dataset)
                                                          })
  
                                                          output$table <- renderTable({
                                                          dataset <- get(input$dataset, "package:datasets")
                                                          dataset
                                                          })'
  
  configContent <- ' # --- Navigation ---
                     # TabName: Tab Name
                      # TabIcon: paper
                         # --- Next/Prev buttons
                        # ShowButtons: TRUE
                     # --- Info ---
                    # InfoTitle: Information
                      # InfoMessage: Some info text'
  
  AddNewTab(serverContent, uiContent, configContent)
  
  # Save all tabs
  SaveAllTabs(input, output, session, currentTabIndexes())
})

  
AddNewTab <- function(serverContent, uiContent, configContent){

  # Update tab index
  tabIndex(tabIndex() + 1)
  
  # Add current tab 
  currentTabIndexes(c(currentTabIndexes(),tabIndex()))
  
  appendTab("EditTabs", tabPanel(tabIndex(), 
                                 bslib::layout_columns(min_height = "10vw", 
                                   textAreaInput(inputId = paste0("tab3-ui",tabIndex()),
                                                 label = paste("Tab ",tabIndex(), "ui.R"),
                                                 value = uiContent,     
                                                 width = "1000%",
                                                 height = "18vw",
                                                 resize = "both"),

                                    textAreaInput(inputId = paste0("tab3-server",tabIndex()),
                                                  label = paste("Tab ",tabIndex(), "server.R"),
                                                  value = serverContent,
                                                  width = "100%",
                                                  height = "18vw",
                                                  resize = "both"),
                                   
                                   textAreaInput(inputId = paste0("tab3-config",tabIndex()),
                                                 label = paste("Tab ",tabIndex(), "config.yml"),
                                                 value = configContent,
                                                 width = "100%",
                                                 height = "18vw",
                                                 resize = "both"),
                                   
                              )), select=TRUE)
}

# -- Delete Tab --- >

observeEvent(input$removeTab, {
    
    shinyWidgets::ask_confirmation(
        inputId = "DelTabConfirmation",
        title = paste("Are you sure to delete ",as.character(input$EditTabs)," ?")
  )
})

observeEvent(input$DelTabConfirmation, {
    
    # read current
      temp <- currentTabIndexes()
      temp <- temp[ !temp == as.numeric(as.character(input$EditTabs))]
      
    # exclude deleted
      currentTabIndexes(c(temp))
    
    # Save all tabs
    SaveAllTabs(input, output, session, currentTabIndexes())
      
    removeTab("EditTabs", target=input$EditTabs)
})


# -- Save project --- >

observeEvent(input$saveTabs, {
  
  # Save all tabs
  SaveAllTabs(input, output, session, currentTabIndexes())
  
})

# -- Run project --- >

observeEvent(input$runTabs, {
 
  # Save all tabs
  SaveAllTabs(input, output, session, currentTabIndexes())
    
  # Run project
  ShinyWizard::RunShinyWizard(loc = config$TempProjPath)

})


# output$result <- renderText({(paste(currentTabIndexes()))})

# You can access the value of the widget with input$text, e.g.

# trigger for change in config 
observeEvent(input$AppTitleInput, { save_config.yaml(input, output, session)}) 
observeEvent(input$AppSubTitleInput, { save_config.yaml(input, output, session)}) 
observeEvent(input$LogoFilePathInput, { save_config.yaml(input, output, session)}) 
observeEvent(input$FooterTextInput, { save_config.yaml(input, output, session)}) 
observeEvent(input$`shinytheme-selector`, { save_config.yaml(input, output, session)}) 

print(input)

#
# This is the user-interface definition of a Shiny web application. You can
# run the application by clicking 'Run App' above.
#


# Source Env
source("global.R")

# Load server functions directory
sapply(paste0("core/ui/",list.files("core/ui")), source)

# Define UI 
shinyUI(fluidPage(
    # Include Theme & CSS
    tags$script(src = "https://unpkg.com/sweetalert/dist/sweetalert.min.js"),
    
    # Bootstrap??
    # tags$script(src = 'https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.bundle.min.js'),
    
    # Use JS
    useShinyjs(),
    
    # Application Title Panel
    GenTitlePanel(),
    
    # Generate Nav Bar
    GenNavTabsUI(), 
    
    # Footer
    GenFooter()

))

# --- Navigation ---
# TabName: Configuration
# TabIcon: cog

# --- Next/Prev buttons
# ShowButtons: TRUE
# ButtonsAlignment: center

fluidPage(
  fluidRow(align="center",

# AppTitleInput  
   textInput(inputId = ns("AppTitleInput"),
             label = "Title",
             value = config$AppTitle),
   tags$script(paste0("/*jslint browser:true*/
               document.getElementById('",ns("AppTitleInput"),"').addEventListener('input', function() {
               document.getElementById('AppTitle').textContent = document.getElementById('",ns("AppTitleInput"),"').value;});")),
   
# AppSubTitle
   textInput(inputId = ns("AppSubTitleInput"),
             label = "Subtitle",
             value = config$AppSubTitle),
   tags$script(paste0("/*jslint browser:true*/
               document.getElementById('",ns("AppSubTitleInput"),"').addEventListener('input', function() {
               document.getElementById('AppSubTitle').textContent = document.getElementById('",ns("AppSubTitleInput"),"').value;});")),

# LogoFilePath
   textInput(inputId = ns("LogoFilePathInput"),
          label = "Logo",
          value = config$LogoFilePath),
   tags$script(paste0("/*jslint browser:true*/
               document.getElementById('",ns("LogoFilePathInput"),"').addEventListener('input', function() {
               document.getElementById('LogoFilePath').src = document.getElementById('",ns("LogoFilePathInput"),"').value;});")),

# FooterText
   textInput(inputId = ns("FooterTextInput"),
          label = "Footer",
          value = config$FooterText),
   tags$script(paste0("/*jslint browser:true*/
               document.getElementById('",ns("FooterTextInput"),"').addEventListener('input', function() {
               document.getElementById('FooterText').textContent = document.getElementById('",ns("FooterTextInput"),"').value;});")),


# Theme selector
   ShinyWizzardThemeSelector()

  )
)

#
# This is the server logic of a Shiny web application. You can run the
# application by clicking 'Run App' above.
#


# Source Env
source("global.R")

# Define server logic required to draw a histogram
shinyServer(function(input, output, session) {
  
    # Load server functions directory
    sapply(paste0("core/server/",list.files("core/server")), source)
    
    # Load tabs server
    load_tabs_server(input, output, session)
    
    # Observe Events on Next Prev Buttons
    observe_event_next_prev_buttons(input, output, session)

    
    
    # Prevent reload page, reload destroys session 
    shinyjs::runjs("window.onbeforeunload = function() {return false; }") # 'For security reason page reload will destroy shiny session and kill the app. Continue?';}")
    
    # onSessionEnded
    session$onSessionEnded(function() { stopApp() })
    
})

#' Observe events on next prev buttons

observe_event_next_prev_buttons <- function(input, output, session){
  
    changePage <- function(from, to) {
      observeEvent(input[[paste0("NavBar-go_", from, "_", to)]], {
        updateTabsetPanel(session, "NavBar-tabs", selected = paste0("tab", to))
      })  
    }
    ids <- seq_along(list.files("tabs"))
    lapply(ids[-1], function(i) changePage(i, i - 1))
    lapply(ids[-length(ids)], function(i) changePage(i, i + 1))
 
}

#' Generate Title Panel

GenTitlePanel <- function(){
  titlePanel(windowTitle = config$AppTitle,
             fluidRow(
               column(11, 
                      tags$div(id = "AppTitle", config$AppTitle), 
                      tags$h5(id = "AppSubTitle", config$AppSubTitle)), 
               column(1, 
                      img(id ="LogoFilePath", style="height: 60px; wigth:60px; float:right; vertical-align:middle", src = config$LogoFilePath)) 
             ))
}

# --- Navigation ---
# TabName: Tabs
# TabIcon: file

# --- Next/Prev buttons
# ShowButtons: TRUE
# ButtonsAlignment: center

# --- Info ---
# InfoTitle: tir
# InfoMessage: mes


fluidPage(
  fluidRow(
    actionButton(ns("newTab"), "Add", icon = icon("plus")),
    actionButton(ns("removeTab"), "Remove", icon = icon("minus")),
    actionButton(ns("saveTabs"), "Save", icon = icon("floppy-disk")),
    actionButton(ns("runTabs"), "Run", icon = icon("play"))
  ),
  tags$br(),
  tabsetPanel(id=ns("EditTabs"), type="pills"),
  
  verbatimTextOutput(outputId = ns("result"))
)

#' @title ShinyWizzard themes
#' 
#' @description
#' Load one of available themes for ShinyWizard project
#'
#' @param name theme name to be applied. No argument returns all available themes.
#' 
#' @return No return value
#' 
# @export

ShinyWizzardTheme <- function(name = ""){
  
  templatesPath <- base::system.file("templates", package = "ShinyWizard")
  templatesList <- base::list.files(paste0(templatesPath, "/css/"))
  # Ext only names
  templatesList <- base::substr(templatesList, 1, base::nchar(templatesList)-8)
   if ( name == ""){
     return(templatesList)
   }else{
     if(base::file.exists(paste0(templatesPath, "/css/", name, ".min.css"))){
       return(paste0(templatesPath, "/css/", name, ".min.css"))
     }else{ 
       stop("The template name '", name, "' is not avaliable. Please use one of ", base::paste(ShinyWizzardTheme(), collapse=", "))}
   }
}

#' ShinyWizzard themes selector
#'
#' @description
#' Shiny selector for themes. It returns a shiny ui code. 
#' 
#' @return Returns js code for ShinyWizzardThemeSelector 
#' 
#' @export

ShinyWizzardThemeSelector <- function() { 
  shiny::fluidRow(align="center",
  shiny::selectInput("tab2-shinytheme-selector", "Theme",
                c(allThemes()),
                selectize = FALSE,
                selected = "flatly", # starting theme
               ),
    
  shiny::tags$script(               # ---- TO-DO: rewrite or move 
      "$('#tab2-shinytheme-selector')
  .on('change', function(el) {
    var allThemes = $(this).find('option').map(function() {
      if ($(this).val() === 'default')
        return 'bootstrap';
      else
        return $(this).val();
    });
    // Find the current theme
    var curTheme = el.target.value;
    if (curTheme === 'default') {
      curTheme = 'bootstrap';
      curThemePath = 'shared/bootstrap/css/bootstrap.min.css';
    } else {
      curThemePath = 'shinythemes/css/' + curTheme + '.min.css';
    }
    // Find the <link> element with that has the bootstrap.css
    var $link = $('link').filter(function() {
      var theme = $(this).attr('href');
      theme = theme.replace(/^.*\\//, '').replace(/(\\.min)?\\.css$/, '');
      return $.inArray(theme, allThemes) !== -1;
    });
    // Set it to the correct path
    $link.attr('href', curThemePath);
  });"
    ),
  )  
  
}

#' @title  All available themes
#'
#' @description
#' List all available themes 
#' 

allThemes <- function() {
  themes <- base::dir(base::system.file("shinythemes/css", package = "shinythemes"),
                ".+\\.min.css")
  base::sub(".min.css", "", themes)
}

#' Save all tabs

SaveAllTabs <- function(input, output, session, currentTabIndexes){
  
  # Temp dir tabs clear and save current
  unlink(config$TempProjPathTabs, recursive = TRUE, force = TRUE)
  dir.create(config$TempProjPathTabs, showWarnings = FALSE)
  
  for (i in currentTabIndexes){
    
    try({
      tabs_dir_n <- paste0(config$TempProjPathTabs,"tab", i,"/")
      dir.create(tabs_dir_n, showWarnings = FALSE)
      write_file(isolate(input[[paste0("ui",i)]]), paste0(tabs_dir_n, "/ui.R"))
      write_file(isolate(input[[paste0("server",i)]]),paste0(tabs_dir_n, "/server.R"))
      write_file(isolate(input[[paste0("config",i)]]),paste0(tabs_dir_n, "/config.yaml"))
    })
  }
}

# Clear Environment
rm(list = ls(all.names = TRUE))

# Load configuration file
config <- yaml::yaml.load_file('config.yaml')

# Additional config
config$TempProjPath <- paste0(tempdir(),"/SWTempProj/") 
config$TempProjPathTabs <- paste0(tempdir(),"/SWTempProj/tabs/") 

# Package names
packages <- c("devtools", "shiny", "shinythemes", "shinydashboard", "shinyjs", "yaml", "readr", "stringr", "shinyWidgets", "bslib", "shinytest2")

# Try loading packages
installedPackages <- basename(find.package(packages))

# # Differences installed vs not
# installedPackagesDiff <- setdiff(packages, installedPackages)
# 
# stop("These packages must be installed: ", installedPackagesDiff)
# 
# Install packages not yet installed
#install.packages(installedPackagesDiff, verbose = FALSE, quiet = TRUE)

# Packages loading
invisible(lapply(packages, library, character.only = TRUE))

# ShinyWizard
library("ShinyWizard")

# --- Navigation ---
# TabName: Download & Deploy
# TabIcon: download

# --- Next/Prev buttons
# ShowButtons: TRUE
# ButtonsAlignment: center


fluidPage(
  fluidRow(
    
    HTML('<center><h1>Download & Deploy Your Project !</h1><br />'),
           
    downloadButton(ns("DownloadShinyWizardZIP"), "Download"),
    
    HTML('<br /> <br /> Downloaded file can be simply deployed by,... '),
    br(),
    br(),
    layout_columns(
      col_width = 3,
      card(
        card_header(HTML("<h3><b>Running in terminal</b></h3><br />")),
        HTML(
          '<br />Open text editor, write command <code> ShinyWizard::RunShinyWizard(&#60;Path to downloaded file&#62;)</code><br /> save file as <code>run.R</code> and run from console by command<br /> <code>Rscript run.R</code>'
        )
      ),
      card(
        card_header(HTML("<h3><b>Running in R studio console</b></h3><br />")),
        HTML(
          'Open R studio, write command to console <br /><br /><code> ShinyWizard::RunShinyWizard(&#60;Path to downloaded file&#62;)</code><br /><br /> and click enter.'
        )
      ),
      card(
        card_header(HTML("<h3><b>Adding to your package</b></h3><br />")),
        HTML(
          'Copy downloaded zip file to the <code>inst/</code> folder of your package and add the command to your package<br /> <br /><code>ShinyWizard::RunShinyWizard(paste0(system.file(package = "&#60;Your package name&#62;"), &#60;downloaded file name&#62;)</code>'
        )
      )
  )
  )
  
   ,verbatimTextOutput(outputId = ns("result")),

)

# Upload Project File
output$contents <- renderText({
  
  # Upload
  file <- input$UploadProjectFile
  ext <- tools::file_ext(file$datapath)
  req(file)
  validate(need(ext == "zip", "Please upload a zip file"))
  
  # Unzip 
  path <- dirname(file$datapath)
  utils::unzip(file$datapath, exdir = path)
  
  # Copy to Temp Proj Dri
  file.copy(paste0(path,'/config.yaml'), config$TempProjPath, recursive=TRUE)
  file.copy(paste0(path,'/tabs'), config$TempProjPath, recursive=TRUE)
  
  # Load config
  load_config.yaml(input, output, session)
  
  # Load tabs
  as.character(paste0(path,"/+/" ,config$TempProjPath))
  
})

# --- Navigation ---
# TabName: Welcome
# TabIcon: home

# --- Next/Prev buttons
# ShowButtons: FALSE

# --- Info ---
# InfoTitle: tir
# InfoMessage: mes

fluidPage(
  fluidRow(
     HTML('<center><h1>Welcome!</h1>
      <p>If you\'re seeing this page, that means Shiny Wizard is installed and running. 
      <strong>Congratulations!</strong> 
      </p>Start new project 
      '),
     br(),
     br(),
        next_prev_button(1,2, NextName = "New Project"),
     br(),
     br(),
     p("or edit an existing (*.zip)"),
     br(),
        fileInput(ns("UploadProjectFile"), NULL, accept = ".zip", multiple = FALSE),
     HTML("</center>"),
     verbatimTextOutput(ns('contents'))
 )
)


# zawsze ns() do id !!!!! lacznie z output każdy id z ns() !!!!!

#' Loading function for tabs

load_tabs_server <- function(input, output, session){

tabs <- list.files("tabs/")

for (i in seq_along(tabs)){
  
  FilePath <- paste0("tabs/",tabs[i],"/server.R")
  
  FileContent <- readr::read_file(file = FilePath)
  
  if ((file.info(FilePath)$size != 0) && (trimws(na.omit(FileContent )) != "")){
    
    pre <- paste0("moduleServer(id = 'tab",i,"',function(input, output, session){")
    aft <- "})"
    
    temp <- tempfile()
    write_file(paste0(pre,FileContent,aft),temp)
    
    source(temp)
  }
 }
}

#' Save config.yaml

save_config.yaml <- function(input, output, session){
  
  # Save config
  #  - Load configuration file original
  temp_config <- yaml::yaml.load_file(system.file("source/config.yaml", package = "ShinyWizard"))
  
  #  - Edit original variables
  temp_config$AppTitle <- input$AppTitleInput
  temp_config$AppSubTitle <- input$AppSubTitleInput
  temp_config$LogoFilePath <- input$LogoFilePathInput
  temp_config$FooterText <- input$FooterTextInput
  temp_config$ShinyWizzardTheme <-  input$`shinytheme-selector` 

  
  # TempProjPath <- paste0(tempdir(),"/SWTempProj/")
  dir.create(config$TempProjPath, showWarnings = FALSE)

  yaml::write_yaml(temp_config, paste0(config$TempProjPath,"config.yaml"))
   
}
